## libhdr-histogram 0.11.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
if(POLICY CMP0135)
    cmake_policy(SET CMP0135 NEW)
    set(CMAKE_POLICY_DEFAULT_CMP0135 NEW)
endif()

file(STRINGS "include/hdr/hdr_histogram_version.h" HDR_VERSION_HEADER)
string(REGEX MATCH ".*#define HDR_HISTOGRAM_VERSION \"(.*)\".*" HDR_BLACK_HOLE ${HDR_VERSION_HEADER})

project(hdr_histogram
    VERSION ${CMAKE_MATCH_1}
    LANGUAGES C
    DESCRIPTION "C port of the HdrHistogram"
    HOMEPAGE_URL "http://hdrhistogram.github.io/HdrHistogram/")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

# Follow all steps below in order to calculate new ABI version when updating the library
# NOTE: THIS IS UNRELATED to the actual project version
#
# 1. If the library source code has changed at all since the last update, then increment revision
# 2. If any interfaces have been added, removed, or changed since the last update, increment current and set revision to 0.
# 3. If any interfaces have been added since the last public release, then increment age.
# 4. If any interfaces have been removed since the last public release, then set age to 0.

set(HDR_SOVERSION_CURRENT   6)
set(HDR_SOVERSION_AGE       1)
set(HDR_SOVERSION_REVISION  3)

set(HDR_VERSION ${HDR_SOVERSION_CURRENT}.${HDR_SOVERSION_AGE}.${HDR_SOVERSION_REVISION})
set(HDR_SOVERSION ${HDR_SOVERSION_CURRENT})
option(HDR_LOG_REQUIRED "HDR Logging component required" ON)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(UNIX)
    add_compile_options(
        -Wall
        -Wno-unknown-pragmas
        -Wextra
        -Wshadow
        -Winit-self
        -Wpedantic
        $<$<COMPILE_LANGUAGE:C>:-Wmissing-prototypes>)
    add_definitions(-D_GNU_SOURCE)
endif()

find_package(ZLIB)
find_package(Threads REQUIRED)

if (HDR_LOG_REQUIRED STREQUAL "DISABLED")
    set(HDR_LOG_ENABLED "FALSE")
else()
    set(HDR_LOG_ENABLED ${ZLIB_FOUND})
    if (${HDR_LOG_REQUIRED} AND NOT HDR_LOG_ENABLED)
        message(SEND_ERROR "HDR_LOG_REQUIRED=ON and unable to find zlib library")
    endif()
endif()

add_subdirectory(include)
add_subdirectory(src)

option(HDR_HISTOGRAM_BUILD_PROGRAMS "Build tests and examples" ON)
if(HDR_HISTOGRAM_BUILD_PROGRAMS)
    include(CTest)

    if(BUILD_TESTING)
        add_subdirectory(test)
    endif()

    add_subdirectory(examples)
endif()

write_basic_package_version_file(
    ${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion)
configure_file(
    config.cmake.in
    ${PROJECT_NAME}-config.cmake
    @ONLY)
if(HDR_HISTOGRAM_INSTALL_SHARED OR HDR_HISTOGRAM_INSTALL_STATIC)
    install(
        EXPORT ${PROJECT_NAME}-targets
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
        NAMESPACE ${PROJECT_NAME}::)
endif()
install(
    FILES
        ${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
        ${PROJECT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

set(CPACK_GENERATOR "TGZ")
include(CPack)

include(JoinPaths)

join_paths(includedir_for_pc_file "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
join_paths(libdir_for_pc_file "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")

if(${ZLIB_FOUND})
    set(PC_REQUIRES_PRIVATE_ZLIB "zlib")
else()
    set(PC_REQUIRES_PRIVATE_ZLIB "")
endif()
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc
    @ONLY
)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== examples/CMakeLists.txt ===
if (HDR_LOG_ENABLED)
    add_executable(hdr_decoder
        hdr_decoder.c)
    target_link_libraries(hdr_decoder
        PRIVATE
            $<$<BOOL:${WIN32}>:hdr_histogram_static>
            $<$<NOT:$<BOOL:${WIN32}>>:hdr_histogram>)
    install(
        TARGETS hdr_decoder
        EXPORT ${PROJECT_NAME}-targets
        DESTINATION ${CMAKE_INSTALL_BINDIR})

    if(CMAKE_SYSTEM_NAME MATCHES "Linux")
        find_package(Threads)

        add_executable(hiccup
            hiccup.c)
        target_link_libraries(hiccup
            PRIVATE
                hdr_histogram
                Threads::Threads)
        install(
            TARGETS hiccup
            EXPORT ${PROJECT_NAME}-targets
            DESTINATION ${CMAKE_INSTALL_BINDIR})
    endif()
endif()

=== include/CMakeLists.txt ===
configure_file(hdr/hdr_histogram_version.h hdr/hdr_histogram_version.h @ONLY)

set(HDR_HISTOGRAM_PUBLIC_HEADERS
    hdr/hdr_histogram.h
    hdr/hdr_histogram_log.h
    hdr/hdr_interval_recorder.h
    hdr/hdr_thread.h
    hdr/hdr_time.h
    hdr/hdr_writer_reader_phaser.h
    hdr/hdr_histogram_version.h)

install(
    FILES ${HDR_HISTOGRAM_PUBLIC_HEADERS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/hdr)

=== src/CMakeLists.txt ===

include(CheckLibraryExists)
check_library_exists(m ceil "" HAVE_LIBM)
check_library_exists(rt clock_gettime "" HAVE_LIBRT)

if (HDR_LOG_ENABLED)
    set(HDR_LOG_IMPLEMENTATION hdr_histogram_log.c)
    set(HDR_ZLIB ZLIB::ZLIB)
else()
    set(HDR_LOG_IMPLEMENTATION hdr_histogram_log_no_op.c)
    set(HDR_ZLIB "")
endif()

set(HDR_HISTOGRAM_SOURCES
    hdr_encoding.c
    hdr_histogram.c
    ${HDR_LOG_IMPLEMENTATION}
    hdr_interval_recorder.c
    hdr_thread.c
    hdr_time.c
    hdr_writer_reader_phaser.c)

set(HDR_HISTOGRAM_PRIVATE_HEADERS
    hdr_atomic.h
    hdr_encoding.h
    hdr_endian.h
    hdr_tests.h
    hdr_malloc.h)

function(hdr_histogram_add_library NAME LIBRARY_TYPE DO_INSTALL)
    add_library(${NAME} ${LIBRARY_TYPE}
        ${HDR_HISTOGRAM_SOURCES}
        ${HDR_HISTOGRAM_PRIVATE_HEADERS}
        ${HDR_HISTOGRAM_PUBLIC_HEADERS})

    target_link_libraries(${NAME}
        PRIVATE
#            ZLIB::ZLIB
            ${HDR_ZLIB}
#            $<$<BOOL:${ZLIB_FOUND}>ZLIB::ZLIB>
            Threads::Threads
            $<$<BOOL:${HAVE_LIBM}>:m>
            $<$<BOOL:${HAVE_LIBRT}>:rt>
            $<$<BOOL:${WIN32}>:ws2_32>)
    target_include_directories(
        ${NAME}
        PUBLIC
            $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/hdr>)
    if(DO_INSTALL)
        install(
            TARGETS ${NAME}
            EXPORT ${PROJECT_NAME}-targets
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
    endif()
endfunction()

option(HDR_HISTOGRAM_BUILD_SHARED "Build shared library" ON)
option(HDR_HISTOGRAM_INSTALL_SHARED "Install shared library" ON)
if(HDR_HISTOGRAM_BUILD_SHARED)
    hdr_histogram_add_library(hdr_histogram SHARED ${HDR_HISTOGRAM_INSTALL_SHARED})
    set_target_properties(hdr_histogram PROPERTIES
        VERSION ${HDR_VERSION}
        SOVERSION ${HDR_SOVERSION})
endif()

option(HDR_HISTOGRAM_BUILD_STATIC "Build static library" ON)
option(HDR_HISTOGRAM_INSTALL_STATIC "Install static library" ON)
if(HDR_HISTOGRAM_BUILD_STATIC)
    hdr_histogram_add_library(hdr_histogram_static STATIC ${HDR_HISTOGRAM_INSTALL_STATIC})
endif()

=== test/CMakeLists.txt ===
option(HDR_HISTOGRAM_BUILD_BENCHMARK "Build benchmark" OFF)
if(HDR_HISTOGRAM_BUILD_BENCHMARK)
    if(UNIX)
        enable_language(CXX)

        include(ExternalProject)

        ExternalProject_Add(google_benchmark
            URL ${PROJECT_SOURCE_DIR}/lib/benchmark-1.6.1.zip
            URL_MD5 d061aaa421b628673cfbdd8b2b4a16a6
            CMAKE_ARGS -DBENCHMARK_ENABLE_TESTING=OFF -DBENCHMARK_ENABLE_INSTALL=OFF
            SOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}/googlebenchmark-src
            BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/googlebenchmark-build
            INSTALL_COMMAND "")

        ExternalProject_Get_Property(google_benchmark SOURCE_DIR)
        set(GOOGLE_BENCHMARK_SOURCE_DIR ${SOURCE_DIR})
        ExternalProject_Get_Property(google_benchmark BINARY_DIR)
        set(GOOGLE_BENCHMARK_BINARY_DIR ${BINARY_DIR})

        add_executable(hdr_histogram_benchmark
            hdr_histogram_benchmark.cpp)
        add_dependencies(hdr_histogram_benchmark
            google_benchmark)
        target_include_directories(hdr_histogram_benchmark
            PRIVATE
                ${GOOGLE_BENCHMARK_SOURCE_DIR}/include)
        target_link_directories(hdr_histogram_benchmark
            PRIVATE
                ${GOOGLE_BENCHMARK_BINARY_DIR}/src)
        target_link_libraries(hdr_histogram_benchmark
            PRIVATE
                benchmark
                hdr_histogram_static)
        install(
            TARGETS hdr_histogram_benchmark
            DESTINATION ${CMAKE_INSTALL_BINDIR})
    else()
        message(WARNING "google.benchmark - microbenchmarks disabled on WIN32 platforms")
    endif()
endif()

function(hdr_histogram_add_test_executable NAME)
    add_executable(${NAME}
        ${NAME}.c
        hdr_test_util.h
        minunit.c
        minunit.h)
    target_link_libraries(${NAME}
        PRIVATE
            hdr_histogram_static)
    target_include_directories(${NAME}
        PRIVATE
            ${PROJECT_SOURCE_DIR}/src)
    install(
        TARGETS ${NAME}
        DESTINATION ${CMAKE_INSTALL_BINDIR})
endfunction()

function(hdr_histogram_add_test NAME)
    hdr_histogram_add_test_executable(${NAME})
    add_test(${NAME} ${NAME})
endfunction()

hdr_histogram_add_test(hdr_histogram_test)
hdr_histogram_add_test(hdr_histogram_atomic_test)
if (HDR_LOG_ENABLED)
    hdr_histogram_add_test(hdr_histogram_log_test)
endif()
hdr_histogram_add_test(hdr_atomic_test)
if(UNIX)
    hdr_histogram_add_test(hdr_histogram_atomic_concurrency_test)
endif()

hdr_histogram_add_test_executable(hdr_histogram_perf)

foreach(V 2.0.1.logV0 2.0.6.logV1 2.0.7S.logV2 2.0.7S.logV3)
    configure_file(jHiccup-${V}.hlog jHiccup-${V}.hlog COPYONLY)
endforeach()

foreach(V 2.0.1.logV0 2.0.6.logV1 2.0.7S.logV2 2.0.7S.logV3)
    configure_file(jHiccup-${V}.hlog jHiccup-${V}.hlog COPYONLY)
endforeach()

foreach(V test_tagged_invalid_histogram.txt test_tagged_invalid_tag_key.txt test_tagged_invalid_timestamp.txt test_tagged_missing_histogram.txt)
    configure_file(${V} ${V} COPYONLY)
endforeach()

=== debian/changelog ===
libhdr-histogram (0.11.8-4) unstable; urgency=medium

  * Link to libatomic on armel

 -- Maytham Alsudany <maytha8thedev@gmail.com>  Sun, 23 Jun 2024 17:58:03 +0800

libhdr-histogram (0.11.8-3) unstable; urgency=medium

  * Add libatomic1 to Build-Depends

 -- Maytham Alsudany <maytha8thedev@gmail.com>  Sun, 23 Jun 2024 15:54:58 +0800

libhdr-histogram (0.11.8-2) unstable; urgency=medium

  [ Micke Nordin ]
  * Add zlib1g-dev to libhdr-histogram-dev's Depends (Closes: #1071261).

  [ Maytham Alsudany ]
  * Run upstream tests with autopkgtest
  * Add myself to uploaders

 -- Maytham Alsudany <maytha8thedev@gmail.com>  Wed, 12 Jun 2024 17:24:53 +0800

libhdr-histogram (0.11.8-1) unstable; urgency=medium

  * Initial release (Closes: #1070643)

 -- Micke Nordin <kano@sunet.se>  Tue, 07 May 2024 17:48:46 +0800

=== debian/control ===
Source: libhdr-histogram
Maintainer: Debian Redict Maintainers <team+redict@tracker.debian.org>
Uploaders:
 Micke Nordin <kano@sunet.se>,
 Maytham Alsudany <maytha8thedev@gmail.com>,
Section: libs
Priority: optional
Standards-Version: 4.7.0
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 zlib1g-dev,
 libatomic1,
Homepage: https://github.com/HdrHistogram/HdrHistogram_c
Vcs-Git: https://salsa.debian.org/redict-team/libhdr-histogram.git
Vcs-Browser: https://salsa.debian.org/redict-team/libhdr-histogram
Rules-Requires-Root: no

Package: libhdr-histogram6
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: High Dynamic Range (HDR) Histogram library
 This C-based implementation of a High Dynamic Range (HDR) Histogram
 contains a subset of the functionality supported by the Java implementation.
 .
 The current supported features are:
  - Standard histogram with 64 bit counts (32/16 bit counts not supported)
  - All iterator types (all values, recorded, percentiles, linear, logarithmic)
  - Histogram serialisation (encoding version 1.2, decoding 1.0-1.2)
  - Reader/writer phaser and interval recorder
 .
 This package contains the shared libraries for libhdr-histogram.

Package: libhdr-histogram-dev
Section: libdevel
Architecture: any
Depends:
 libhdr-histogram6 (= ${binary:Version}),
 zlib1g-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: High Dynamic Range (HDR) Histogram library (development files)
 This C-based implementation of a High Dynamic Range (HDR) Histogram
 contains a subset of the functionality supported by the Java implementation.
 .
 The current supported features are:
  - Standard histogram with 64 bit counts (32/16 bit counts not supported)
  - All iterator types (all values, recorded, percentiles, linear, logarithmic)
  - Histogram serialisation (encoding version 1.2, decoding 1.0-1.2)
  - Reader/writer phaser and interval recorder
 .
 This package contains the development files for libhdr-histogram.

Package: libhdr-histogram-examples
Section: utils
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: High Dynamic Range (HDR) Histogram library (examples)
 This C-based implementation of a High Dynamic Range (HDR) Histogram
 contains a subset of the functionality supported by the Java implementation.
 .
 The current supported features are:
  - Standard histogram with 64 bit counts (32/16 bit counts not supported)
  - All iterator types (all values, recorded, percentiles, linear, logarithmic)
  - Histogram serialisation (encoding version 1.2, decoding 1.0-1.2)
  - Reader/writer phaser and interval recorder
 .
 This package contains the example applications.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Link to libatomic on armel
ifneq (,$(filter $(DEB_HOST_ARCH), armel))
	export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
    https://github.com/HdrHistogram/HdrHistogram_c/tags \
    (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
